const source_code = JSON.parse("\"import fs_implementation from 'node:fs';\\nimport process from 'node:process';\\nimport path from 'node:path';\\n\\nfunction sync_impl$g(fs, path, mode) {\\n\\tfs.chmodSync(path, mode);\\n}\\n\\nasync function async_impl$g(fs, path, mode) {\\n\\tawait fs.promises.chmod(path, mode);\\n}\\n\\nvar chmod = {sync_impl: sync_impl$g, async_impl: async_impl$g};\\n\\nfunction sync_impl$f(fs, path, uid, gid) {\\n\\tfs.chownSync(path, uid, gid);\\n}\\n\\nasync function async_impl$f(fs, path, uid, gid) {\\n\\tawait fs.promises.chown(path, uid, gid);\\n}\\n\\nvar chown = {sync_impl: sync_impl$f, async_impl: async_impl$f};\\n\\nfunction sync_impl$e(fs, src, dest) {\\n\\tfs.copyFileSync(src, dest);\\n}\\n\\nasync function async_impl$e(fs, src, dest) {\\n\\tawait fs.promises.copyFile(src, dest);\\n}\\n\\nvar copyFile = {sync_impl: sync_impl$e, async_impl: async_impl$e};\\n\\nfunction sync_impl$d(fs, path) {\\n\\treturn fs.lstatSync(path)\\n}\\n\\nasync function async_impl$d(fs, path) {\\n\\treturn await fs.promises.lstat(path)\\n}\\n\\nvar lstat = {sync_impl: sync_impl$d, async_impl: async_impl$d};\\n\\nfunction sync_impl$c(fs, path, options = null) {\\n\\tif (options === null) {\\n\\t\\tfs.mkdirSync(path);\\n\\t} else {\\n\\t\\tfs.mkdirSync(path, options);\\n\\t}\\n}\\n\\nasync function async_impl$c(fs, path, options = null) {\\n\\tif (options === null) {\\n\\t\\tawait fs.promises.mkdir(path);\\n\\t} else {\\n\\t\\tawait fs.promises.mkdir(path, options);\\n\\t}\\n}\\n\\nvar mkdir = {sync_impl: sync_impl$c, async_impl: async_impl$c};\\n\\nfunction sync_impl$b(fs, path) {\\n\\tconst handle = fs.opendirSync(path);\\n\\n\\treturn {\\n\\t\\tread() {\\n\\t\\t\\treturn handle.readSync()\\n\\t\\t},\\n\\t\\tclose() {\\n\\t\\t\\thandle.closeSync();\\n\\t\\t}\\n\\t}\\n}\\n\\nasync function async_impl$b(fs, path) {\\n\\tconst handle = await fs.promises.opendir(path);\\n\\n\\treturn {\\n\\t\\tasync read() {\\n\\t\\t\\treturn await handle.read()\\n\\t\\t},\\n\\t\\tasync close() {\\n\\t\\t\\tawait handle.close();\\n\\t\\t}\\n\\t}\\n}\\n\\nvar openDirectory = {sync_impl: sync_impl$b, async_impl: async_impl$b};\\n\\nfunction sync_impl$a(fs, path, flags = \\\"r\\\", mode = 0o666) {\\n\\tconst fd = fs.openSync(path, flags, mode);\\n\\n\\treturn {\\n\\t\\tread(buffer) {\\n\\t\\t\\treturn fs.readSync(fd, buffer)\\n\\t\\t},\\n\\t\\twrite(buffer) {\\n\\t\\t\\treturn fs.writeSync(fd, buffer)\\n\\t\\t},\\n\\t\\tclose() {\\n\\t\\t\\tfs.closeSync(fd);\\n\\t\\t}\\n\\t}\\n}\\n\\nasync function async_impl$a(fs, path, flags = \\\"r\\\", mode = 0o666) {\\n\\tconst handle = await fs.promises.open(path, flags, mode);\\n\\n\\treturn {\\n\\t\\tasync read(buffer) {\\n\\t\\t\\tconst {bytesRead} = await handle.read(buffer, 0, buffer.byteLength, null);\\n\\n\\t\\t\\treturn bytesRead\\n\\t\\t},\\n\\t\\tasync write(buffer) {\\n\\t\\t\\tconst {bytesWritten} = await handle.write(buffer);\\n\\n\\t\\t\\treturn bytesWritten\\n\\t\\t},\\n\\t\\tasync close() {\\n\\t\\t\\tawait handle.close();\\n\\t\\t}\\n\\t}\\n}\\n\\nvar openFile = {sync_impl: sync_impl$a, async_impl: async_impl$a};\\n\\nfunction sync_impl$9(fs, path) {\\n\\treturn fs.readFileSync(path)\\n}\\n\\nasync function async_impl$9(fs, path) {\\n\\treturn await fs.promises.readFile(path)\\n}\\n\\nvar readFile = {sync_impl: sync_impl$9, async_impl: async_impl$9};\\n\\nfunction sync_impl$8(fs, path) {\\n\\treturn fs.readdirSync(path)\\n}\\n\\nasync function async_impl$8(fs, path) {\\n\\treturn await fs.promises.readdir(path)\\n}\\n\\nvar readdir = {sync_impl: sync_impl$8, async_impl: async_impl$8};\\n\\nfunction sync_impl$7(fs, path) {\\n\\treturn fs.readlinkSync(path)\\n}\\n\\nasync function async_impl$7(fs, path) {\\n\\treturn await fs.promises.readlink(path)\\n}\\n\\nvar readlink = {sync_impl: sync_impl$7, async_impl: async_impl$7};\\n\\nfunction sync_impl$6(fs, path) {\\n\\treturn fs.realpathSync(path)\\n}\\n\\nasync function async_impl$6(fs, path) {\\n\\treturn await fs.promises.realpath(path)\\n}\\n\\nvar realpath = {sync_impl: sync_impl$6, async_impl: async_impl$6};\\n\\nfunction sync_impl$5(fs, src, dest) {\\n\\tfs.renameSync(src, dest);\\n}\\n\\nasync function async_impl$5(fs, src, dest) {\\n\\tawait fs.promises.rename(src, dest);\\n}\\n\\nvar rename = {sync_impl: sync_impl$5, async_impl: async_impl$5};\\n\\nfunction sync_impl$4(fs, path) {\\n\\tfs.rmdirSync(path);\\n}\\n\\nasync function async_impl$4(fs, path) {\\n\\tawait fs.promises.rmdir(path);\\n}\\n\\nvar rmdir = {sync_impl: sync_impl$4, async_impl: async_impl$4};\\n\\nfunction sync_impl$3(fs, path) {\\n\\treturn fs.statSync(path)\\n}\\n\\nasync function async_impl$3(fs, path) {\\n\\treturn await fs.promises.stat(path)\\n}\\n\\nvar stat = {sync_impl: sync_impl$3, async_impl: async_impl$3};\\n\\nfunction sync_impl$2(fs, target, path) {\\n\\tfs.symlinkSync(target, path);\\n}\\n\\nasync function async_impl$2(fs, target, path) {\\n\\tawait fs.promises.symlink(target, path);\\n}\\n\\nvar symlink = {sync_impl: sync_impl$2, async_impl: async_impl$2};\\n\\nfunction sync_impl$1(fs, path) {\\n\\tfs.unlinkSync(path);\\n}\\n\\nasync function async_impl$1(fs, path) {\\n\\tawait fs.promises.unlink(path);\\n}\\n\\nvar unlink = {sync_impl: sync_impl$1, async_impl: async_impl$1};\\n\\nfunction sync_impl$h(fs, path, data) {\\n\\treturn fs.writeFileSync(path, data)\\n}\\n\\nasync function async_impl$h(fs, path, data) {\\n\\treturn await fs.promises.writeFile(path, data)\\n}\\n\\nvar writeFile = {sync_impl: sync_impl$h, async_impl: async_impl$h};\\n\\n/* warning: this file was automatically generated */\\n\\nvar methods = {\\n    chmod,\\n    chown,\\n    copyFile,\\n    lstat,\\n    mkdir,\\n    openDirectory,\\n    openFile,\\n    readFile,\\n    readdir,\\n    readlink,\\n    realpath,\\n    rename,\\n    rmdir,\\n    stat,\\n    symlink,\\n    unlink,\\n    writeFile,\\n};\\n\\nfunction createFSObject({\\n\\tsync = false\\n} = {}) {\\n\\tlet fs_object = {};\\n\\n\\tfor (const method_name in methods) {\\n\\t\\tconst method = methods[method_name];\\n\\t\\tconst method_implementation = sync ? method.sync_impl : method.async_impl;\\n\\n\\t\\tfs_object[method_name] = (...args) => {\\n\\n\\t\\t\\tif (process.env) {\\n\\t\\t\\t\\tif (\\\"ANIO_NODE_FS_API_DEBUG\\\" in process.env) {\\n\\t\\t\\t\\t\\tconsole.error(`anio-node-fs-api ${method_name}${sync ? \\\"Sync\\\" : \\\"Async\\\"} with args`, args);\\n\\t\\t\\t\\t}\\n\\t\\t\\t}\\n\\n\\t\\t\\treturn method_implementation(fs_implementation, ...args)\\n\\t\\t};\\n\\t}\\n\\n\\treturn fs_object\\n}\\n\\nfunction scandir$2(fs_object, root_dir, relative_entry_dir, options) {\\n\\tconst entries = fs_object.readdir(\\n\\t\\tpath.join(root_dir, relative_entry_dir)\\n\\t);\\n\\n\\tfor (const entry of entries) {\\n\\t\\tconst absolute_path = path.join(root_dir, relative_entry_dir, entry);\\n\\t\\tconst relative_path = path.join(relative_entry_dir, entry);\\n\\t\\tconst stats = fs_object.lstat(absolute_path);\\n\\n\\t\\tlet type = \\\"file\\\";\\n\\n\\t\\tif (stats.isSymbolicLink()) {\\n\\t\\t\\ttype = \\\"link\\\";\\n\\t\\t} else if (stats.isDirectory()) {\\n\\t\\t\\ttype = \\\"dir\\\";\\n\\t\\t}\\n\\n\\t\\tconst handle_current_entry = () => {\\n\\t\\t\\tconst data = {type, relative_path, absolute_path};\\n\\n\\t\\t\\tif (typeof options.filter === \\\"function\\\") {\\n\\t\\t\\t\\tconst keep = options.filter(data);\\n\\n\\t\\t\\t\\tif (keep !== true) return\\n\\t\\t\\t}\\n\\n\\t\\t\\tif (typeof options.callback === \\\"function\\\") {\\n\\t\\t\\t\\toptions.callback(data);\\n\\n\\t\\t\\t\\treturn\\n\\t\\t\\t}\\n\\n\\t\\t\\toptions.entries.push(data);\\n\\t\\t};\\n\\n\\t\\tconst recurse = () => {\\n\\t\\t\\tif (type !== \\\"dir\\\") return\\n\\n\\t\\t\\tscandir$2(fs_object, root_dir, relative_path, options);\\n\\t\\t};\\n\\n\\t\\tif (options.reverse === true) recurse();\\n\\n\\t\\thandle_current_entry();\\n\\n\\t\\t// written this way so \\\"if statement\\\" has same length as options.reverse === true\\n\\t\\tif (options.reverse !== true) recurse();\\n\\t}\\n}\\n\\nfunction sync_impl(fs_object, root_dir, {\\n\\tcallback = null,\\n\\treverse = false,\\n\\tsorted = false,\\n\\tfilter = null\\n} = {}) {\\n\\tlet entries = [];\\n\\tconst options = {callback, reverse, filter, entries};\\n\\tconst resolved_root_path = fs_object.realpath(root_dir);\\n\\n\\tscandir$2(fs_object, resolved_root_path, \\\".\\\", options);\\n\\n\\tif (sorted) {\\n\\t\\tentries.sort((a, b) => {\\n\\t\\t\\treturn a.relative_path.localeCompare(b.relative_path, \\\"en\\\")\\n\\t\\t});\\n\\t}\\n\\n\\treturn typeof callback === \\\"function\\\" ? null : entries\\n}\\n\\nasync function scandir$1(fs_object, root_dir, relative_entry_dir, options) {\\n\\tconst entries = await fs_object.readdir(\\n\\t\\tpath.join(root_dir, relative_entry_dir)\\n\\t);\\n\\n\\tfor (const entry of entries) {\\n\\t\\tconst absolute_path = path.join(root_dir, relative_entry_dir, entry);\\n\\t\\tconst relative_path = path.join(relative_entry_dir, entry);\\n\\t\\tconst stats = await fs_object.lstat(absolute_path);\\n\\n\\t\\tlet type = \\\"file\\\";\\n\\n\\t\\tif (stats.isSymbolicLink()) {\\n\\t\\t\\ttype = \\\"link\\\";\\n\\t\\t} else if (stats.isDirectory()) {\\n\\t\\t\\ttype = \\\"dir\\\";\\n\\t\\t}\\n\\n\\t\\tconst handle_current_entry = async () => {\\n\\t\\t\\tconst data = {type, relative_path, absolute_path};\\n\\n\\t\\t\\tif (typeof options.filter === \\\"function\\\") {\\n\\t\\t\\t\\tconst keep = await options.filter(data);\\n\\n\\t\\t\\t\\tif (keep !== true) return\\n\\t\\t\\t}\\n\\n\\t\\t\\tif (typeof options.callback === \\\"function\\\") {\\n\\t\\t\\t\\tawait options.callback(data);\\n\\n\\t\\t\\t\\treturn\\n\\t\\t\\t}\\n\\n\\t\\t\\toptions.entries.push(data);\\n\\t\\t};\\n\\n\\t\\tconst recurse = async () => {\\n\\t\\t\\tif (type !== \\\"dir\\\") return\\n\\n\\t\\t\\tawait scandir$1(fs_object, root_dir, relative_path, options);\\n\\t\\t};\\n\\n\\t\\tif (options.reverse === true) await recurse();\\n\\n\\t\\tawait handle_current_entry();\\n\\n\\t\\t// written this way so \\\"if statement\\\" has same length as options.reverse === true\\n\\t\\tif (options.reverse !== true) await recurse();\\n\\t}\\n}\\n\\nasync function async_impl(fs_object, root_dir, {\\n\\tcallback = null,\\n\\treverse = false,\\n\\tsorted = false,\\n\\tfilter = null\\n} = {}) {\\n\\tlet entries = [];\\n\\tconst options = {callback, reverse, filter, entries};\\n\\tconst resolved_root_path = await fs_object.realpath(root_dir);\\n\\n\\tawait scandir$1(fs_object, resolved_root_path, \\\".\\\", options);\\n\\n\\tif (sorted) {\\n\\t\\tentries.sort((a, b) => {\\n\\t\\t\\treturn a.relative_path.localeCompare(b.relative_path, \\\"en\\\")\\n\\t\\t});\\n\\t}\\n\\n\\treturn typeof callback === \\\"function\\\" ? null : entries\\n}\\n\\nconst async_fs = createFSObject({sync: false});\\nconst sync_fs = createFSObject({sync: true});\\n\\nfunction scandir(path, options = {}) {\\n\\treturn async_impl(async_fs, path, options)\\n}\\n\\nfunction scandirSync(path, options = {}) {\\n\\treturn sync_impl(sync_fs, path, options)\\n}\\n\\nexport { scandir, scandirSync };\\n\"");

export default source_code;
